package com.blogspot.thedsweb.engine;

import org.opencv.core.Mat;
import org.opencv.core.MatOfRect;
import org.opencv.objdetect.CascadeClassifier;

import com.blogspot.thedsweb.util.Database;

public class Face {
	private boolean faceNow;
	private boolean faceBefore;
	private CascadeClassifier faceDetector = new CascadeClassifier(Database.PATHTOXML);
	
	public Face() {
		//Initialize face values
		faceNow = false;
		faceBefore = false;
	}
	
	public boolean detectFace(Mat frame, int meanValue) {
		//Return true if it is to dark to track faces correctly
		if ( meanValue < 50 ) {
			return true;
		}
		
		//Save old face value and get new one
		swapFace(frame);
		
		//Return true as long as faceNow or faceBefore are true
		return faceNow || faceBefore;
	}
	
	private void swapFace(Mat frame) {
		//Save faceNow value in faceBefore
		faceBefore = faceNow;
		
		//Set faceNow new
		faceNow = detect(frame);
	}
	
	private boolean detect(Mat frame) {
		//Detect Faces on Frame and return true if there are Faces and return false if not
		MatOfRect faceDetections = new MatOfRect();
		faceDetector.detectMultiScale(frame, faceDetections);
		return faceDetections.toArray().length != 0;
	}
}
