package com.blogspot.thedsweb.util;

import java.io.BufferedWriter;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;
import java.io.IOException;

public class Files {
	public Files() {
	}
	
	public static String readStatus(int[] arr) {
		//Read in all saved or used files and store the values in an array
		if ( arr == null || arr.length < 4 ) {
			throw new IllegalArgumentException();
		} else {
			GeneratePath brightness = new GeneratePath();
			String path = brightness.getBrightnessPath();
			arr[0] = readInt(Database.PATHMIN);
			arr[1] = readInt(Database.PATHMAX);
			arr[2] = readInt(Database.PATHLAST);
			arr[3] = readInt(brightness.getMaxBrightnessPath());
			return path;
		}
	}
	
	//read int from file
	public static int readInt(String arg) {
		return Integer.parseInt(read(arg));
	}
	
	//read string from file
	public static String readString(String arg) {
		return read(arg);
	}
	
	private static String read(String arg) {
		//Buffered read out of an file
		BufferedReader br = null;
		String result = "";
		
		try {
			br = new BufferedReader( new FileReader( arg ) );
			result = br.readLine();
		} catch ( IOException e ) {
			e.printStackTrace();
		} finally {
			try {
				if ( br != null ) {
					br.close();
				}
			} catch ( IOException ex ) {
				ex.printStackTrace();
			}
		}
		
		return result;
	}
	
	public static void saveValue(int x, int y, int z) {
		// Save the minimum OR maximum AND last brightness 
		// value into different files 
		if ( x == y ) {
			writeInt(x, Database.PATHMIN);
		}
		if ( x == z ) {
			writeInt(x, Database.PATHMAX);
		}
		writeInt(x, Database.PATHLAST);
	}
	
	//write int values to file
	public static void writeInt(int x, String path) {
		String arg = Integer.toString(x);
		write(arg, path);
	}
	
	//rewrite configurations file
	public static void writeConfig() {
		write(Database.CONFIGCONTENT, Database.PATHTOCONFIGFILE);
	}
	
	//write to file
	private static void write(String arg, String path) {
		//Buffered write into an file
		try {
			if ( path != "" ) {
				File file = new File(path);
				
				if ( !file.exists() ) {
					file.createNewFile();
				}
				
				FileWriter fw = new FileWriter(file.getAbsoluteFile());
				BufferedWriter bw = new BufferedWriter(fw);
				
				bw.write(arg);
				bw.close();
			} else {
				throw new IllegalArgumentException();
			}
		} catch ( IOException e ) {
			e.printStackTrace();
		}
	}
	
	//Try to delete the pid file of yawls
	public static void deletePid() {
    	try{
    		File file = new File(Database.PATHPID);
    		file.delete();
    	}catch( Exception e ){
    		e.printStackTrace();
    	}
	}
}
