package com.blogspot.thedsweb.util;

import java.io.File;

import com.blogspot.thedsweb.error.NoBacklightDeviceFound;

public class GeneratePath {
	private String max_brightness;
	private String brightness;
	private String bestType;
	
	public GeneratePath() {
		File folder = new File("/sys/class/backlight");
		File[] listOfFiles = folder.listFiles();
		if ( listOfFiles == null || listOfFiles.length == 0 ) {
			try {
				throw new NoBacklightDeviceFound();
			} catch (NoBacklightDeviceFound e) {
				e.printStackTrace();
			}
		}
		
		//Chose best sysfs control files by type firmware > platform > raw
		bestType = bestChoice(listOfFiles);
		
		max_brightness = classBrightness("max_brightness");
		brightness = classBrightness("brightness");
	}
	
	public String getBrightnessPath() {
		return brightness;
	}
	
	public String getMaxBrightnessPath() {
		return max_brightness;
	}
	
	private String classBrightness( String arg ){
		//Try to get the correct path for main display max_brightness control file
		return "/sys/class/backlight/" + bestType + "/" + arg;
	}
	
	//Sysfs test for best type of control
	private String bestChoice(File[] listOfFiles) {
		String[] types = {"firmware","platform","raw"};
		String check;
		for ( String type : types ) {
			for ( int i = 0; i < listOfFiles.length; i++ ) {
				check = Files.readString("/sys/class/backlight/" + listOfFiles[i].getName() + "/type");
				if ( type.equalsIgnoreCase(check) ) {
					return listOfFiles[i].getName();
				}
			}
		}
		return listOfFiles[0].getName();
	}
}
