package com.blogspot.thedsweb.util;

import java.io.File;
import java.io.RandomAccessFile;
import java.nio.channels.FileLock;

public final class SingleInstance {
	private SingleInstance() {
	}
	
	public static boolean lockInstance() {
		// Generate a lockfile with fileLock to prevent complications
		// if File is doesen't deleted after interruption
		try {
			final File file = new File(Database.PATHLOCK);
			if (!file.exists()) {
				file.createNewFile();
			}
			final RandomAccessFile randomAccessFile = new RandomAccessFile(file, "rw");
			final FileLock fileLock = randomAccessFile.getChannel().tryLock();
			if ( fileLock != null ) {
				Runtime.getRuntime().addShutdownHook(new Thread() {
					public void run() {
						try {
							fileLock.release();
							randomAccessFile.close();
							file.delete();
						} catch ( Exception e ) {
							throw new RuntimeException();
						}
					}
				});
				return true;
			}
		} catch ( Exception e ) {
			throw new RuntimeException();
		}
		return false;
	}
}
