#!/bin/bash
#
# Author: Dominik Brämer <thedsweb@googlemail.com>
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

export NO_AT_BRIDGE=1

NAME="yawls"

#Refresh symlink to OpenCV jar file
OPENCVJAR=$(ls /usr/share/OpenCV/java)
ln -sf "/usr/share/OpenCV/java/$OPENCVJAR" '/usr/share/yawls/opencv.jar' &>/dev/null

#Path to openjdk 7
JAVA="/usr/lib/jvm/java-7-openjdk-*/bin/java"

#Start program
$JAVA -jar '/usr/share/yawls/yawls.jar' $@ &

#Create pid file if not existing already 
PID=$!
if [[ ! -f /var/run/$NAME.pid ]]; then
	trap "rm -f /var/run/$NAME.pid" 0 1 2 3 15 &>/dev/null
	echo $PID > /var/run/$NAME.pid &>/dev/null
	wait $PID
else
	wait $PID
fi
